/**
 * @author Renpi Yu
 *
 * To change this generated comment edit the template variable "typecomment":
 * Window>Preferences>Java>Templates.
 * To enable and disable the creation of type comments go to
 * Window>Preferences>Java>Code Generation.
 */
	//Example Swing program to illustrate a very simple text editor
        //Need to import classes from all these packages
import java.awt.*;
import javax.swing.*;
import java.awt.event.*;
import javax.swing.border.*;
import java.io.*;
public class NetlistEditor extends JFrame {
  //Instance variables for the GUI components used.
  //Declaring the variables here allows them to be
  //used by any instance methods in the class.
  JPanel topPanel;
  JPanel leftButtonPanel;
  JPanel editorPanel;
  JButton loadButton;
  JButton saveButton;
  JButton cutButton;
  JButton copyButton;
  JButton pasteButton;
  JScrollPane scroller;
  JTextArea editor;
  private TestClass m_testClass;
  
  private String netlistPath = null;
  private String netlistDir = null;
  private MessageBox alert;
  
  //public File openedFile;
  //The constructor build the window using a utility
  //method and displays it.
  public NetlistEditor(TestClass theTestClass) {
	m_testClass = theTestClass;
	//Create and configure the various panels
	topPanel = new JPanel ();
	topPanel.setLayout (new BorderLayout ());
        
	editorPanel = new JPanel ();
	editorPanel.setLayout(new BorderLayout ());
	editorPanel.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
	leftButtonPanel = new JPanel ();
//	rightButtonPanel = new JPanel ();
//	rightButtonPanel.setBorder(BorderFactory.createEtchedBorder());
	leftButtonPanel.setBorder(BorderFactory.createEtchedBorder ());
        
	//The panel containing the buttons uses a GridLayout of 1 column
	//and 5 rows to position the buttons in a column.
	GridLayout grid = new GridLayout ();
	grid.setColumns(1);
	grid.setHgap(10);
	grid.setRows(5); //Set a small gap between the buttons
	grid.setVgap(3); //to improve the appearance
//	GridLayout grid2 = new GridLayout();
//	grid2.setColumns(1);
//	grid2.setHgap(10);
//	grid2.setRows(3);
//	grid2.setVgap(3);
	leftButtonPanel.setLayout(grid);
//	rightButtonPanel.setLayout(grid2);

	//Now create the buttons, giving each a listener to respond to
	//the button being clicked. The listener methods delegate to
	//private helper methods later in the class, to avoid the
	//constructor method becoming too long and unwieldy.
	loadButton = new JButton("Load");
	loadButton.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		loadFile();
	  }
	});
	saveButton = new JButton("Save");
	saveButton.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		saveFile();
	  }
	});
	cutButton = new JButton("Cut");
	cutButton.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		cut();
	  }
	});
	copyButton = new JButton("Copy");
	copyButton.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		copy();
	  }
	});
	pasteButton = new JButton("Paste");
	pasteButton.addActionListener(new java.awt.event.ActionListener() {
	  public void actionPerformed(ActionEvent e) {
		paste();
	  }
	});
 

// ADD ACTIONLISTENER HERE FOR INSTALL PANEL
        
        leftButtonPanel.add(loadButton);
	leftButtonPanel.add(saveButton);
	leftButtonPanel.add(cutButton);
	leftButtonPanel.add(copyButton);
	leftButtonPanel.add(pasteButton);
 
        //The editor component handles all text display and editing. It
	//is given a width of 40 characters.
	scroller = new JScrollPane();
	editor = new JTextArea ();
	editor.setColumns(40);
        editorPanel.add(scroller, BorderLayout.CENTER);
	scroller.getViewport().add(editor);
        
        //Now assemble the components
	topPanel.add(leftButtonPanel, BorderLayout.WEST);
//	topPanel.add(rightButtonPanel, BorderLayout.EAST);
	topPanel.add(editorPanel, BorderLayout.EAST);
        
	//Configure the top-level JFrame
	setTitle("netlistEditor");
	getContentPane().add(topPanel, BorderLayout.CENTER);
	addWindowListener(new java.awt.event.WindowAdapter() {
	  public void windowClosing(WindowEvent e) {
		e.getWindow().setVisible(false);
	  }
	});

        alert = new MessageBox(this, "alert", "Please upload netlist file or create netlist file first...", 300);
	pack();
        setLocation(10,200);
	setVisible(true);
  }
  
  //The following methods implement the button click behaviour.
  //Display a file dialog and load a file.
  private void loadFile() {
	JFileChooser fc = new JFileChooser();
	int returnVal = fc.showOpenDialog(this);
	if (returnVal == JFileChooser.APPROVE_OPTION) {
	  //If a file was selected, try and load it.
	  File file = fc.getSelectedFile();
	  try {
		editor.read(new FileReader(file), null);
	  }
	  catch (IOException exp) {}
          m_testClass.setNetlistPath(file.getAbsolutePath());
          m_testClass.setNetlistDir(file.getParent());
	  MainWindow.tArea.append("Netlist file loaded from:   " + file.getParent() + "\n");
	}
  }
  //Display a save file dialog and save the current file.
  private void saveFile() {
	JFileChooser fc = new JFileChooser ();
	int returnVal = fc.showSaveDialog(this);
	if (returnVal == JFileChooser.APPROVE_OPTION) {
	  File file = fc.getSelectedFile();
	  //openedFile = file;
	  try {
		editor.write(new FileWriter(file));
	  }
	  catch (IOException exp) {}
          m_testClass.setNetlistPath(file.getAbsolutePath());
          m_testClass.setNetlistDir(file.getParent());
          MainWindow.tArea.append("Netlist file saved in:   " + file.getParent() + "\n");
	}
  }
  //Cut, copy and paste are implemented using methods provided by a
  //superclass of the JTextArea class, and work with the system
  //clipboard. Very useful and makes it very easy to implement
  //cut/copy/paste!!
  //
  //The requestFocus method is used to make the JTextArea the active
  //component after a button is clicked. The component with the focus
  //receives the input events. If focus is not returned to the
  //JTextArea it remains with the button, preventing text being
  //entered into the text area until it is clicked on to regain
  //focus.
  private void copy() {
	editor.copy();
	editor.requestFocus();
  }
  private void paste() {
	editor.paste();
	editor.requestFocus();
  }
  private void cut() {
	editor.cut();
	editor.requestFocus();
  }
 


  public static void main(final String[] args) {
	final netlistEditor editor = new netlistEditor ();
  }
}
